#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

# dimacsファイルを読み込む
dimacsfile = File.readlines(ARGV[0]).map{ |line| line.chomp }
beginning = dimacsfile.index("c ---------- VARIABLES ----------")
ending = dimacsfile.index("c ---------- CONSTRAINT ----------")
if !beginning || !ending
  raise "Not a dimacs file generated by generate_sudoku.rb"
end

table = []
dimacsfile[(beginning+1)...ending].each do |line|
  if line =~ /\Ac (\d+) /
    table[$1.to_i] = $'
  else
    raise "Invalid comment: \"#{line}\""
  end
end

# minisatが出力した結果のファイルを読み込む
resultfile = File.readlines(ARGV[1]).map{ |line| line.chomp }

if resultfile[0] != "SAT"
  raise "Invalid result file (not satisfied?)"
end

numbers = resultfile[1].split(' ').map{ |s| Integer(s) }

numbers.each do |n|
  if n > 0
    puts table[n]
  end
end

